/*******************************************************************************
 * FoxDestructibleSkeletalMeshActor generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDestructibleSkeletalMeshActor extends SkeletalMeshActor
    native
    hidecategories(Navigation);

struct native BreakableStepSkeletal
{
    struct native BreakableParticleSystemSkeletal
    {
        var() ParticleSystem Emitter;
        var EmitterSpawnable SpawnedEmitter;
        var() Vector Offset;

        structdefaultproperties
        {
            Emitter=none
            SpawnedEmitter=none
            Offset=(X=0.0,Y=0.0,Z=0.0)
        }
    };

    struct native DamageStep
    {
        var() float DamageAmount;
        var() name Animation;

        structdefaultproperties
        {
            DamageAmount=0.0
            Animation=None
        }
    };

    var() float DamageThreshold;
    var() array<BreakableParticleSystemSkeletal> ParticleEmitters;
    var() SkeletalMesh BreakMesh;
    var() Engine.Actor.EPhysics Physics;
    var() SoundCue BreakSound;
    var int AccumulatedDamage;
    var int CurrentDamageStep;
    var() array<DamageStep> DamageSteps;
    var() int AwardPoints;

    structdefaultproperties
    {
        DamageThreshold=0.0
        ParticleEmitters=none
        BreakMesh=none
        Physics=EPhysics.PHYS_RigidBody
        BreakSound=none
        AccumulatedDamage=0
        CurrentDamageStep=0
        DamageSteps=none
        AwardPoints=50
    }
};

var bool bBroken;
var(Destruction) bool bParticlesAcceptLights;
var(Destruction) bool bParticlesAcceptDynamicLights;
var(Destruction) array< class<DamageType> > DamageTypes;
var(Destruction) array<BreakableStepSkeletal> BreakableSteps;
var int CurrentBreakableStep;
var(Destruction) LightingChannelContainer ParticleLightingChannels;

// Export UFoxDestructibleSkeletalMeshActor::execGetOffsetToWorld(FFrame&, void* const)
native function Vector GetOffsetToWorld(Vector Offset);

// Export UFoxDestructibleSkeletalMeshActor::execSetParticlesLighting(FFrame&, void* const)
native function SetParticlesLighting(Emitter Emit);

simulated function TakeRadiusDamage(Controller InstigatedBy, float BaseDamage, float DamageRadius, class<DamageType> DamageType, float Momentum, Vector HurtOrigin, bool bFullDamage, Actor DamageCauser, optional float DamageFalloffExponent)
{
    local float ColRadius, ColHeight, DamageScale, Dist, ScaledDamage;

    local Vector Dir;

    DamageFalloffExponent = 1.0;
    GetBoundingCylinder(ColRadius, ColHeight);
    Dir = Location - HurtOrigin;
    Dist = VSize(Dir);
    Dir = Normal(Dir);
    // End:0x8C
    if(bFullDamage)
    {
        DamageScale = 1.0;
    }
    // End:0x100
    else
    {
        Dist = FMax(Dist - ColRadius, 0.0);
        DamageScale = FClamp(1.0 - (Dist / DamageRadius), 0.0, 1.0);
        DamageScale = DamageScale ** DamageFalloffExponent;
    }
    // End:0x1B2
    if(DamageScale > 0.0)
    {
        ScaledDamage = DamageScale * BaseDamage;
        TakeDamage(int(ScaledDamage), InstigatedBy, Location - ((0.50 * (ColHeight + ColRadius)) * Dir), (DamageScale * Momentum) * Dir, DamageType,, DamageCauser);
    }
    super(Actor).TakeRadiusDamage(InstigatedBy, BaseDamage, DamageRadius, DamageType, Momentum, HurtOrigin, bFullDamage, DamageCauser, DamageFalloffExponent);
    //return;    
}

event TakeDamage(int Damage, Controller EventInstigator, Vector HitLocation, Vector Momentum, class<DamageType> DamageType, optional TraceHitInfo HitInfo, optional Actor DamageCauser)
{
    local AnimNodeSequence SeqNode;
    local BreakableStepSkeletal CurrentStep;

    CurrentStep = BreakableSteps[CurrentBreakableStep];
    BreakableSteps[CurrentBreakableStep].AccumulatedDamage += Damage;
    // End:0x263
    if((CurrentStep.CurrentDamageStep < CurrentStep.DamageSteps.Length) && float(CurrentStep.AccumulatedDamage) >= CurrentStep.DamageSteps[CurrentStep.CurrentDamageStep].DamageAmount)
    {
        BreakableSteps[CurrentBreakableStep].AccumulatedDamage -= int(CurrentStep.DamageSteps[CurrentStep.CurrentDamageStep].DamageAmount);
        SeqNode = AnimNodeSequence(SkeletalMeshComponent.Animations);
        SeqNode.SetAnim(CurrentStep.DamageSteps[CurrentStep.CurrentDamageStep].Animation);
        SeqNode.PlayAnim(false, 1.0, 0.0);
        ++ BreakableSteps[CurrentBreakableStep].CurrentDamageStep;
    }
    // End:0x2E3
    if(IsValidDamageType(DamageType))
    {
        // End:0x2BD
        if(CurrentBreakableStep == (BreakableSteps.Length - 1))
        {
            TakeLastDamage(Damage, EventInstigator, false, CurrentBreakableStep);
        }
        // End:0x2E3
        else
        {
            TakeStepDamage(Damage, EventInstigator, false, CurrentBreakableStep);
        }
    }
    super.TakeDamage(Damage, EventInstigator, HitLocation, Momentum, DamageType, HitInfo, DamageCauser);
    //return;    
}

function TakeLastDamage(int Damage, Controller EventInstigator, bool bIsBroken, int BrokenStep)
{
    BreakableSteps[CurrentBreakableStep].DamageThreshold -= float(Damage);
    // End:0x77
    if(BreakableSteps[CurrentBreakableStep].DamageThreshold < float(0))
    {
        BreakLastApart(EventInstigator);
    }
    // End:0x97
    else
    {
        // End:0x97
        if(bIsBroken)
        {
            BreakStepApart(BrokenStep);
        }
    }
    // End:0x127
    if(BreakableSteps[CurrentBreakableStep].AwardPoints > 0)
    {
        FoxPRI(EventInstigator.PlayerReplicationInfo).AddCombatPoints(BreakableSteps[CurrentBreakableStep].AwardPoints);
    }
    //return;    
}

function TakeStepDamage(int Damage, Controller EventInstigator, bool bIsBroken, int BrokenStep)
{
    // End:0x4B
    if(CurrentBreakableStep < BreakableSteps.Length)
    {
        BreakableSteps[CurrentBreakableStep].DamageThreshold -= float(Damage);
    }
    // End:0x1DD
    if((CurrentBreakableStep < BreakableSteps.Length) && BreakableSteps[CurrentBreakableStep].DamageThreshold < float(0))
    {
        // End:0xF8
        if(CurrentBreakableStep == (BreakableSteps.Length - 1))
        {
            TakeStepDamage(int(-BreakableSteps[CurrentBreakableStep].DamageThreshold), EventInstigator, true, CurrentBreakableStep);
        }
        // End:0x13F
        else
        {
            TakeLastDamage(int(-BreakableSteps[CurrentBreakableStep].DamageThreshold), EventInstigator, true, CurrentBreakableStep);
        }
        // End:0x1CF
        if(BreakableSteps[CurrentBreakableStep].AwardPoints > 0)
        {
            FoxPRI(EventInstigator.PlayerReplicationInfo).AddCombatPoints(BreakableSteps[CurrentBreakableStep].AwardPoints);
        }
        ++ CurrentBreakableStep;
    }
    // End:0x1FD
    else
    {
        // End:0x1FD
        if(bIsBroken)
        {
            BreakStepApart(BrokenStep);
        }
    }
    //return;    
}

final function bool IsValidDamageType(class<DamageType> inDamageType)
{
    local bool bValid;

    bValid = true;
    // End:0x44
    if(DamageTypes.Length > 0)
    {
        bValid = DamageTypes.Find(inDamageType) != -1;
    }
    return bValid;
    //return ReturnValue;    
}

function BreakStepApart(int BrokenStep)
{
    local EmitterSpawnable Emit;
    local int I;
    local Vector SpawnLocation;

    // End:0x14D
    if(BrokenStep > 0)
    {
        // End:0x14D
        if(BreakableSteps[BrokenStep - 1].ParticleEmitters.Length > 0)
        {
            I = 0;
            J0x4A:
            // End:0x14D [Loop If]
            if(I < BreakableSteps[BrokenStep - 1].ParticleEmitters.Length)
            {
                // End:0x13F
                if(BreakableSteps[BrokenStep - 1].ParticleEmitters[I].SpawnedEmitter != none)
                {
                    BreakableSteps[BrokenStep - 1].ParticleEmitters[I].SpawnedEmitter.ParticleSystemComponent.DeactivateSystem();
                }
                ++ I;
                // [Loop Continue]
                goto J0x4A;
            }
        }
    }
    // End:0x3D0
    if((WorldInfo.NetMode != NM_DedicatedServer) && BreakableSteps[BrokenStep].ParticleEmitters.Length > 0)
    {
        I = 0;
        J0x1B0:
        // End:0x3D0 [Loop If]
        if(I < BreakableSteps[BrokenStep].ParticleEmitters.Length)
        {
            // End:0x3C2
            if(BreakableSteps[BrokenStep].ParticleEmitters[I].Emitter != none)
            {
                SpawnLocation = Location + BreakableSteps[BrokenStep].ParticleEmitters[I].Offset;
                Emit = FoxGRI(WorldInfo.GRI).ObjectPool.GetEmitter(BreakableSteps[BrokenStep].ParticleEmitters[I].Emitter, SpawnLocation, Rotation);
                // End:0x3C2
                if(Emit != none)
                {
                    SetParticlesLighting(Emit);
                    Emit.SetBase(self);
                    BreakableSteps[BrokenStep].ParticleEmitters[I].SpawnedEmitter = Emit;
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x1B0;
        }
    }
    // End:0x461
    if(BreakableSteps[BrokenStep].BreakSound != none)
    {
        PlaySound(BreakableSteps[BrokenStep].BreakSound, true,,, CollisionComponent.Bounds.Origin);
    }
    // End:0x4D3
    if(BreakableSteps[BrokenStep].BreakMesh != none)
    {
        SkeletalMeshComponent.SetSkeletalMesh(BreakableSteps[BrokenStep].BreakMesh);
    }
    SetPhysics(BreakableSteps[BrokenStep].Physics);
    // End:0x54D
    if(BreakableSteps[BrokenStep].Physics == 10)
    {
        SkeletalMeshComponent.WakeRigidBody();
    }
    //return;    
}

function BreakLastApart(Controller EventInstigator)
{
    local EmitterSpawnable Emit;
    local int I;
    local SkeletalMeshActorSpawnable SpawnedActor;
    local Vector SpawnLocation;

    bBroken = true;
    // End:0x159
    if(CurrentBreakableStep > 0)
    {
        // End:0x159
        if(BreakableSteps[CurrentBreakableStep - 1].ParticleEmitters.Length > 0)
        {
            I = 0;
            J0x56:
            // End:0x159 [Loop If]
            if(I < BreakableSteps[CurrentBreakableStep - 1].ParticleEmitters.Length)
            {
                // End:0x14B
                if(BreakableSteps[CurrentBreakableStep - 1].ParticleEmitters[I].SpawnedEmitter != none)
                {
                    BreakableSteps[CurrentBreakableStep - 1].ParticleEmitters[I].SpawnedEmitter.ParticleSystemComponent.DeactivateSystem();
                }
                ++ I;
                // [Loop Continue]
                goto J0x56;
            }
        }
    }
    // End:0x3DC
    if((WorldInfo.NetMode != NM_DedicatedServer) && BreakableSteps[CurrentBreakableStep].ParticleEmitters.Length > 0)
    {
        I = 0;
        J0x1BC:
        // End:0x3DC [Loop If]
        if(I < BreakableSteps[CurrentBreakableStep].ParticleEmitters.Length)
        {
            // End:0x3CE
            if(BreakableSteps[CurrentBreakableStep].ParticleEmitters[I].Emitter != none)
            {
                SpawnLocation = Location + BreakableSteps[CurrentBreakableStep].ParticleEmitters[I].Offset;
                Emit = FoxGRI(WorldInfo.GRI).ObjectPool.GetEmitter(BreakableSteps[CurrentBreakableStep].ParticleEmitters[I].Emitter, SpawnLocation, Rotation);
                // End:0x3CE
                if(Emit != none)
                {
                    SetParticlesLighting(Emit);
                    Emit.SetBase(self);
                    BreakableSteps[CurrentBreakableStep].ParticleEmitters[I].SpawnedEmitter = Emit;
                }
            }
            ++ I;
            // [Loop Continue]
            goto J0x1BC;
        }
    }
    SetPhysics(0);
    SetCollision(false, false);
    // End:0x416
    if(CollisionComponent != none)
    {
        CollisionComponent.SetBlockRigidBody(false);
    }
    SetTimer(0.10, false, 'HideAndDestroy');
    // End:0x457
    if(EventInstigator != none)
    {
        TriggerEventClass(class'SeqEvent_Destroyed', EventInstigator);
    }
    // End:0x4E8
    if(BreakableSteps[CurrentBreakableStep].BreakSound != none)
    {
        PlaySound(BreakableSteps[CurrentBreakableStep].BreakSound, true,,, CollisionComponent.Bounds.Origin);
    }
    // End:0x655
    if(BreakableSteps[CurrentBreakableStep].BreakMesh != none)
    {
        SpawnedActor = Spawn(class'SkeletalMeshActorSpawnable',,, Location, Rotation);
        // End:0x655
        if(SpawnedActor != none)
        {
            SpawnedActor.SkeletalMeshComponent.SetSkeletalMesh(BreakableSteps[CurrentBreakableStep].BreakMesh);
            SpawnedActor.SetPhysics(BreakableSteps[CurrentBreakableStep].Physics);
            // End:0x655
            if(BreakableSteps[CurrentBreakableStep].Physics == 10)
            {
                SpawnedActor.SkeletalMeshComponent.WakeRigidBody();
            }
        }
    }
    //return;    
}

function HideAndDestroy()
{
    SkeletalMeshComponent.SetHidden(true);
    Destroy();
    //return;    
}

defaultproperties
{
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructibleSkeletalMeshActor.MyLightEnvironment'
    object end
    // Reference: SkeletalMeshComponent'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0'
    SkeletalMeshComponent=SkeletalMeshComponent0
    LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructibleSkeletalMeshActor.MyLightEnvironment'
    FacialAudioComp=AudioComponent'Default__FoxDestructibleSkeletalMeshActor.FaceAudioComponent'
    Components(0)=DynamicLightEnvironmentComponent'Default__FoxDestructibleSkeletalMeshActor.MyLightEnvironment'
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructibleSkeletalMeshActor.MyLightEnvironment'
    object end
    // Reference: SkeletalMeshComponent'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0'
    Components(1)=SkeletalMeshComponent0
    Components(2)=AudioComponent'Default__FoxDestructibleSkeletalMeshActor.FaceAudioComponent'
    CollisionType=ECollisionType.COLLIDE_BlockAll
    BlockRigidBody=true
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        Animations=AnimNodeSequence'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0.AnimNodeSeq0'
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxDestructibleSkeletalMeshActor.MyLightEnvironment'
    object end
    // Reference: SkeletalMeshComponent'Default__FoxDestructibleSkeletalMeshActor.SkeletalMeshComponent0'
    CollisionComponent=SkeletalMeshComponent0
}